#
# Conditional build:
%bcond_with	default_lua	# build as default lua (symlinks to nil suffix)
#
Summary:	A simple lightweight powerful embeddable programming language
Summary(pl.UTF-8):	Prosty, lekki ale potężny, osadzalny język programowania
Summary(pt_BR.UTF-8):	Lua é uma linguagem de programação poderosa e leve, projetada para estender aplicações.
Name:		lua40
Version:	4.0.1
%define refman_ver 4.0
Release:	13
License:	BSD-like (see docs)
Group:		Development/Languages
Source0:	http://www.lua.org/ftp/lua-%{version}.tar.gz
# Source0-md5:	a31d963dbdf727f9b34eee1e0d29132c
Source1:	http://www.lua.org/ftp/refman-%{refman_ver}.ps.gz
# Source1-md5:	5454698095c45917ce80c934066cb76c
Patch0:		lua-link.patch
Patch1:		lua-OPT.patch
URL:		http://www.lua.org/
Requires:	%{name}-libs = %{version}-%{release}
%if %{with default_lua}
Provides:	lua = %{version}
Obsoletes:	lua < %{version}
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Lua is a powerful, light-weight programming language designed for
extending applications. It is also frequently used as a
general-purpose, stand-alone language. It combines simple procedural
syntax (similar to Pascal) with powerful data description constructs
based on associative arrays and extensible semantics. Lua is
dynamically typed, interpreted from bytecodes, and has automatic
memory management with garbage collection, making it ideal for
configuration, scripting, and rapid prototyping.

This version has compiled in support for dynamic libraries in baselib.

%description -l pl.UTF-8
Lua to język programowania o dużych możliwościach ale lekki,
przeznaczony do rozszerzania aplikacji. Jest też często używany jako
samodzielny język ogólnego przeznaczenia. Łączy prostą proceduralną
składnię (podobną do Pascala) z potężnymi konstrukcjami opisu danych
bazującymi na tablicach asocjacyjnych i rozszerzalnej składni. Lua ma
dynamiczny system typów, interpretowany z bytecodu i automatyczne
zarządzanie pamięcią z odśmiecaczem, co czyni go idealnym do
konfiguracji, skryptów i szybkich prototypów.

Ta wersja ma wkompilowaną obsługę ładowania dynamicznych bibliotek.

%description -l pt_BR.UTF-8
Lua é uma linguagem de programação poderosa e leve, projetada para
estender aplicações. Lua também é freqüentemente usada como uma
linguagem de propósito geral.
Lua combina programação procedural com poderosas construções para
descrição de dados, baseadas em tabelas associativas e semântica
extensível. Lua é tipada dinamicamente, interpretada a partir de
bytecodes, e tem gerenciamento automático de memória com coleta de
lixo. Essas características fazem de Lua uma linguagem ideal para
configuração, automação (scripting) e prototipagem rápida.

%package libs
Summary:	Lua 4.0.x shared libraries
Summary(pl.UTF-8):	Biblioteki współdzielone Lua 4.0.x
Group:		Libraries
Conflicts:	lua40 < 4.0.1-7

%description libs
Lua 4.0.x shared libraries.

%description libs -l pl.UTF-8
Biblioteki współdzielone Lua 4.0.x.

%package devel
Summary:	Header files for Lua
Summary(pl.UTF-8):	Pliki nagłówkowe dla Lua
Summary(pt_BR.UTF-8):	Arquivos de cabeçalho para a linguagem Lua
Group:		Development/Languages
Requires:	%{name}-libs = %{version}-%{release}
%if %{with default_lua}
Provides:	lua-devel = %{version}
Obsoletes:	lua-devel <= 4.0.1
%endif

%description devel
Header files needed to embed Lua in C/C++ programs and docs for the
language.

%description devel -l pl.UTF-8
Pliki nagłówkowe potrzebne do włączenia Lua do programów w C/C++ oraz
dokumentacja samego języka.

%description devel -l pt_BR.UTF-8
Contém os arquivos de cabeçalho para desenvolvimento e extensão da
linguagem Lua.

%package static
Summary:	Static Lua libraries
Summary(pl.UTF-8):	Biblioteki statyczne Lua
Summary(pt_BR.UTF-8):	Bibliotecas estáticas para desenvolvimento com a linguagem Lua
Group:		Development/Languages
Requires:	%{name}-devel = %{version}-%{release}
%if %{with default_lua}
Provides:	lua-static = %{version}
Obsoletes:	lua-static < %{version}
%endif

%description static
Static Lua libraries.

%description static -l pl.UTF-8
Biblioteki statyczne Lua.

%description static -l pt_BR.UTF-8
Bibliotecas estáticas para desenvolvimento com a linguagem Lua.

%prep
%setup -q -n lua-%{version}
cp -f %{SOURCE1} refman.ps.gz

%patch0 -p1
%patch1 -p1

%build
%{__make} -j1 all so sobin \
	CC="%{__cc}" \
	OPT="%{rpmcflags}" \
	EXTRA_DEFS="-fPIC -DPIC -D_GNU_SOURCE"

%{__rm} test/{lua,luac}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_libdir}/lua,%{_datadir}/lua}

%{__make} install \
	INSTALL_ROOT=$RPM_BUILD_ROOT%{_prefix} \
	INSTALL_BIN=$RPM_BUILD_ROOT%{_bindir} \
	INSTALL_INC=$RPM_BUILD_ROOT%{_includedir}/lua4.0 \
	INSTALL_LIB=$RPM_BUILD_ROOT%{_libdir} \
	INSTALL_MAN=$RPM_BUILD_ROOT%{_mandir}/man1

# change name from lua to lua4.0
for i in $RPM_BUILD_ROOT%{_bindir}/lua* ; do
	%{__mv} ${i}{,4.0}
done
%{__mv} $RPM_BUILD_ROOT%{_mandir}/man1/lua{,4.0}.1
%{__mv} $RPM_BUILD_ROOT%{_mandir}/man1/luac{,4.0}.1
%{__mv} $RPM_BUILD_ROOT%{_libdir}/liblua{,4.0}.a
%{__mv} $RPM_BUILD_ROOT%{_libdir}/liblualib{,4.0}.a

ln -sf liblua.so.4.0 $RPM_BUILD_ROOT%{_libdir}/liblua4.0.so
ln -sf liblualib.so.4.0 $RPM_BUILD_ROOT%{_libdir}/liblualib4.0.so

%if %{with default_lua}
for f in lua luac ; do
	ln -sf ${f}4.0 $RPM_BUILD_ROOT%{_bindir}/${f}
	echo ".so ${f}4.0.1" >$RPM_BUILD_ROOT%{_mandir}/man1/${f}.1
done
ln -sf liblua4.0.a $RPM_BUILD_ROOT%{_libdir}/liblua.a
ln -sf liblualib4.0.a $RPM_BUILD_ROOT%{_libdir}/liblualib.a
ln -sf lua4.0 $RPM_BUILD_ROOT%{_includedir}/lua
%else
%{__rm} $RPM_BUILD_ROOT%{_libdir}/lib{lua,lualib}.so
%endif

%{__rm} doc/*.1

%clean
rm -rf $RPM_BUILD_ROOT

%post   libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/lua4.0
%attr(755,root,root) %{_bindir}/luac4.0
%{_mandir}/man1/lua4.0.1*
%{_mandir}/man1/luac4.0.1*
%if %{with default_lua}
%attr(755,root,root) %{_bindir}/lua
%attr(755,root,root) %{_bindir}/luac
%{_mandir}/man1/lua.1*
%{_mandir}/man1/luac.1*
%endif

%files libs
%defattr(644,root,root,755)
%doc COPYRIGHT HISTORY README
%attr(755,root,root) %{_libdir}/liblua.so.4.0
%attr(755,root,root) %{_libdir}/liblualib.so.4.0

%files devel
%defattr(644,root,root,755)
%doc refman.ps.gz doc test
%attr(755,root,root) %{_libdir}/liblua4.0.so
%attr(755,root,root) %{_libdir}/liblualib4.0.so
%{_includedir}/lua4.0
%if %{with default_lua}
%attr(755,root,root) %{_libdir}/liblua.so
%attr(755,root,root) %{_libdir}/liblualib.so
%{_includedir}/lua
%endif

%files static
%defattr(644,root,root,755)
%{_libdir}/liblua4.0.a
%{_libdir}/liblualib4.0.a
%if %{with default_lua}
%{_libdir}/liblua.a
%{_libdir}/liblualib.a
%endif
%changelog
* Fri Nov 06 2020 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/lua40.git;a=log;h=master

* Fri Nov 06 2020 Jakub Bogusz <qboosh@pld-linux.org> 6a39063
- really provide lua-devel only when building as default_lua; release 13

* Fri Oct 30 2020 Jakub Bogusz <qboosh@pld-linux.org> 957420c
- provide lua{,-devel,-static} only when built as default_lua; unify suffixes to "4.0"; release 12

* Mon Jan 30 2012 Elan Ruusamäe <glen@pld-linux.org> 67c8bec
- -libs Group: Libraries

* Mon Jul 28 2008 Arkadiusz Miśkiewicz <arekm@maven.pl> f8d02c8
- release 11

* Tue Feb 13 2007 Elan Ruusamäe <glen@pld-linux.org> 29db373
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> c4179c9
- converted to UTF-8

* Mon May 09 2005 Jakub Bogusz <qboosh@pld-linux.org> 08fa40d
- Obsoletes for lua <= 4.0.1 packages (before switching to lua40* names)

* Sat Apr 10 2004 Jakub Bogusz <qboosh@pld-linux.org> fb80a6c
- don't rename shared libs themselves - they don't conflict and renaming them
  caused problems with soname symlinks
- release 10

* Sun Mar 28 2004 wolf <wolf@pld-linux.org> 1901376
- let lua40 and lua50 coexist

* Sat Aug 02 2003 migo <migo@pld-linux.org> 3449d68
- lua40-libs conflicts: lua40 < 4.0.1-7
- release 8

* Wed Jul 23 2003 undefine <undefine@pld-linux.org> 5f4ab5f
- pt_BR translation

* Wed May 28 2003 Michal Moskal <michal@moskal.me> 0cac6d5
- massive attack: source-md5

* Sun May 25 2003 misi3k <misi3k@pld-linux.org> fb9df10
- massive attack s/pld.org.pl/pld-linux.org/

* Wed May 14 2003 Jakub Bogusz <qboosh@pld-linux.org> b042e0e
- base R: -libs, added libs descriptions

* Wed May 14 2003 Artur Frysiak <artur@frysiak.net> 79c83e4
- added libs package

* Mon May 12 2003 Artur Frysiak <artur@frysiak.net> 597418e
- allow installing lua50 without uninstaling lua40

* Fri Jan 10 2003 kloczek <kloczek@pld-linux.org> 84bc85a
- cosmetics.

* Sat Dec 28 2002 Jakub Bogusz <qboosh@pld-linux.org> 70af91c
- OK, my mistake... fixed, link patch is back

* Fri Dec 27 2002 depesz <depesz@depesz.pl> ca66852
- patch commented out - now it compiles
- somebody (rrw???) who knows this software should check this out

* Wed Dec 18 2002 Jakub Bogusz <qboosh@pld-linux.org> 054afdf
- added link patch (link using gcc not ld, set SONAME)
- release 5

